diff --git a/src/libponyc/codegen/codegen.c b/src/libponyc/codegen/codegen.c
index 3ad4f25a3f..aa93beef31 100644
--- a/src/libponyc/codegen/codegen.c
+++ b/src/libponyc/codegen/codegen.c
@@ -763,6 +763,26 @@ static void init_runtime(compile_t* c)
   // i32 pony_personality_v0(...)
   type = LLVMFunctionType(c->i32, NULL, 0, true);
   c->personality = LLVMAddFunction(c->module, "pony_personality_v0", type);
+
+  // i32 memcmp(i8*, i8*, intptr)
+  params[0] = c->void_ptr;
+  params[1] = c->void_ptr;
+  params[2] = c->intptr;
+  type = LLVMFunctionType(c->i32, params, 3, false);
+  value = LLVMAddFunction(c->module, "memcmp", type);
+#if PONY_LLVM >= 309
+  LLVMAddAttributeAtIndex(value, LLVMAttributeFunctionIndex, nounwind_attr);
+  LLVMAddAttributeAtIndex(value, LLVMAttributeFunctionIndex, readonly_attr);
+  LLVMAddAttributeAtIndex(value, 1, readonly_attr);
+  LLVMAddAttributeAtIndex(value, 2, readonly_attr);
+#else
+  LLVMAddFunctionAttr(value, LLVMNoUnwindAttribute);
+  LLVMAddFunctionAttr(value, LLVMReadOnlyAttribute);
+  LLVMValueRef param = LLVMGetParam(value, 0);
+  LLVMAddAttribute(param, LLVMReadOnlyAttribute);
+  param = LLVMGetParam(value, 1);
+  LLVMAddAttribute(param, LLVMReadOnlyAttribute);
+#endif
 }
 
 static bool init_module(compile_t* c, ast_t* program, pass_opt_t* opt)
@@ -1010,6 +1030,7 @@ bool codegen_gen_test(compile_t* c, ast_t* program, pass_opt_t* opt)
 
   reach(c->reach, main_ast, c->str_create, NULL, opt);
   reach(c->reach, env_ast, c->str__create, NULL, opt);
+  reach_done(c->reach, c->opt);
 
   if(opt->limit == PASS_REACH)
     return true;
diff --git a/src/libponyc/codegen/codegen.h b/src/libponyc/codegen/codegen.h
index ab81664fb0..966b97a66b 100644
--- a/src/libponyc/codegen/codegen.h
+++ b/src/libponyc/codegen/codegen.h
@@ -174,6 +174,7 @@ typedef struct compile_t
   LLVMValueRef none_instance;
   LLVMValueRef primitives_init;
   LLVMValueRef primitives_final;
+  LLVMValueRef numeric_sizes;
 
   LLVMTypeRef void_type;
   LLVMTypeRef ibool;
diff --git a/src/libponyc/codegen/gendesc.c b/src/libponyc/codegen/gendesc.c
index 6ea661dc95..e929550a39 100644
--- a/src/libponyc/codegen/gendesc.c
+++ b/src/libponyc/codegen/gendesc.c
@@ -311,7 +311,7 @@ static LLVMValueRef make_vtable(compile_t* c, reach_type_t* t)
       pony_assert(index != (uint32_t)-1);
       pony_assert(vtable[index] == NULL);
 
-      if(t->primitive != NULL)
+      if((t->primitive != NULL) && !m->internal)
         vtable[index] = make_unbox_function(c, t, m);
       else
         vtable[index] = make_desc_ptr(m->func, c->void_ptr);
@@ -372,7 +372,7 @@ void gendesc_type(compile_t* c, reach_type_t* t)
   const char* desc_name = genname_descriptor(t->name);
   uint32_t traits = trait_count(t, NULL, NULL);
   uint32_t fields = 0;
-  uint32_t vtable_size = 0;
+  uint32_t vtable_size = t->vtable_size;
 
   if(t->underlying == TK_TUPLETYPE)
     fields = t->field_count;
@@ -444,10 +444,23 @@ void gendesc_init(compile_t* c, reach_type_t* t)
 
 void gendesc_table(compile_t* c)
 {
-  uint32_t len = c->reach->next_type_id;
+  uint32_t object_id_max = (c->reach->object_type_count * 2) + 1;
+  uint32_t numeric_id_max = c->reach->numeric_type_count * 4;
+  uint32_t tuple_id_max = (c->reach->tuple_type_count * 4) + 2;
+
+  uint32_t len = object_id_max;
+  if(len < numeric_id_max)
+    len = numeric_id_max;
+  if(len < tuple_id_max)
+    len = tuple_id_max;
+
   size_t size = len * sizeof(LLVMValueRef);
   LLVMValueRef* args = (LLVMValueRef*)ponyint_pool_alloc_size(size);
 
+  LLVMValueRef null = LLVMConstNull(c->descriptor_ptr);
+  for(size_t i = 0; i < len; i++)
+    args[i] = null;
+
   reach_type_t* t;
   size_t i = HASHMAP_BEGIN;
 
@@ -498,6 +511,11 @@ LLVMValueRef gendesc_fetch(compile_t* c, LLVMValueRef object)
   return desc;
 }
 
+LLVMValueRef gendesc_typeid(compile_t* c, LLVMValueRef object)
+{
+  return desc_field(c, gendesc_fetch(c, object), DESC_ID);
+}
+
 LLVMValueRef gendesc_trace(compile_t* c, LLVMValueRef object)
 {
   return desc_field(c, gendesc_fetch(c, object), DESC_TRACE);
diff --git a/src/libponyc/codegen/gendesc.h b/src/libponyc/codegen/gendesc.h
index ac2ba2b90f..4a85e46c14 100644
--- a/src/libponyc/codegen/gendesc.h
+++ b/src/libponyc/codegen/gendesc.h
@@ -16,6 +16,8 @@ void gendesc_table(compile_t* c);
 
 LLVMValueRef gendesc_fetch(compile_t* c, LLVMValueRef object);
 
+LLVMValueRef gendesc_typeid(compile_t* c, LLVMValueRef object);
+
 LLVMValueRef gendesc_trace(compile_t* c, LLVMValueRef object);
 
 LLVMValueRef gendesc_dispatch(compile_t* c, LLVMValueRef object);
diff --git a/src/libponyc/codegen/genexe.c b/src/libponyc/codegen/genexe.c
index 5feb6e2460..421cb493c6 100644
--- a/src/libponyc/codegen/genexe.c
+++ b/src/libponyc/codegen/genexe.c
@@ -386,6 +386,7 @@ bool genexe(compile_t* c, ast_t* program)
     fprintf(stderr, " Reachability\n");
   reach(c->reach, main_ast, c->str_create, NULL, c->opt);
   reach(c->reach, env_ast, c->str__create, NULL, c->opt);
+  reach_done(c->reach, c->opt);
 
   if(c->opt->limit == PASS_REACH)
     return true;
diff --git a/src/libponyc/codegen/genident.c b/src/libponyc/codegen/genident.c
index 21289ebaf1..050fca3a62 100644
--- a/src/libponyc/codegen/genident.c
+++ b/src/libponyc/codegen/genident.c
@@ -1,11 +1,71 @@
 #include "genident.h"
+#include "genbox.h"
+#include "gencall.h"
 #include "gendesc.h"
 #include "genexpr.h"
+#include "genopt.h"
+#include "../type/subtype.h"
+#include "../../libponyrt/mem/pool.h"
 #include "ponyassert.h"
+#include <string.h>
 
 static LLVMValueRef gen_is_value(compile_t* c, ast_t* left_type,
   ast_t* right_type, LLVMValueRef l_value, LLVMValueRef r_value);
 
+enum boxed_subtypes_t
+{
+  BOXED_SUBTYPES_NONE,
+  BOXED_SUBTYPES_NUMERIC = 1 << 0,
+  BOXED_SUBTYPES_TUPLE = 1 << 1,
+  BOXED_SUBTYPES_UNBOXED = 1 << 2,
+
+  BOXED_SUBTYPES_BOXED = BOXED_SUBTYPES_NUMERIC | BOXED_SUBTYPES_TUPLE,
+  BOXED_SUBTYPES_ALL = BOXED_SUBTYPES_BOXED | BOXED_SUBTYPES_UNBOXED
+};
+
+static int boxed_subtypes_overlap(reach_t* reach, ast_t* left_type,
+  ast_t* right_type)
+{
+  reach_type_t* r_left = reach_type(reach, left_type);
+  reach_type_t* r_right = reach_type(reach, right_type);
+
+  int subtypes = BOXED_SUBTYPES_NONE;
+
+  size_t i = HASHMAP_BEGIN;
+  reach_type_t* sub_left;
+
+  while((sub_left = reach_type_cache_next(&r_left->subtypes, &i)) != NULL)
+  {
+    if(!sub_left->can_be_boxed)
+    {
+      subtypes |= BOXED_SUBTYPES_UNBOXED;
+      if(subtypes == BOXED_SUBTYPES_ALL)
+        return subtypes;
+
+      continue;
+    }
+
+    size_t j = HASHMAP_BEGIN;
+    reach_type_t* sub_right;
+
+    while((sub_right = reach_type_cache_next(&r_right->subtypes, &j)) != NULL)
+    {
+      if(sub_left == sub_right)
+      {
+        if(sub_left->underlying == TK_PRIMITIVE)
+          subtypes |= BOXED_SUBTYPES_NUMERIC;
+        else
+          subtypes |= BOXED_SUBTYPES_TUPLE;
+
+        if(subtypes == BOXED_SUBTYPES_ALL)
+          return subtypes;
+      }
+    }
+  }
+
+  return subtypes;
+}
+
 static LLVMValueRef tuple_is(compile_t* c, ast_t* left_type, ast_t* right_type,
   LLVMValueRef l_value, LLVMValueRef r_value)
 {
@@ -39,7 +99,8 @@ static LLVMValueRef tuple_is(compile_t* c, ast_t* left_type, ast_t* right_type,
 
     // If false, go directly to the post block.
     LLVMBuildCondBr(c->builder, test, next_block, post_block);
-    LLVMAddIncoming(phi, &test, &this_block, 1);
+    LLVMBasicBlockRef current_block = LLVMGetInsertBlock(c->builder);
+    LLVMAddIncoming(phi, &test, &current_block, 1);
 
     // Point to the next block.
     this_block = next_block;
@@ -61,6 +122,158 @@ static LLVMValueRef tuple_is(compile_t* c, ast_t* left_type, ast_t* right_type,
   return phi;
 }
 
+static LLVMValueRef raw_is_box(compile_t* c, ast_t* left_type,
+  LLVMValueRef l_value, LLVMValueRef r_value)
+{
+  pony_assert(LLVMGetTypeKind(LLVMTypeOf(r_value)) == LLVMPointerTypeKind);
+
+  LLVMValueRef r_desc = gendesc_fetch(c, r_value);
+  LLVMValueRef same_type = gendesc_isentity(c, r_desc, left_type);
+  pony_assert(same_type != GEN_NOVALUE);
+
+  LLVMBasicBlockRef this_block = LLVMGetInsertBlock(c->builder);
+  LLVMBasicBlockRef value_block = codegen_block(c, "is_value");
+  LLVMBasicBlockRef post_block = codegen_block(c, "is_post");
+  LLVMBuildCondBr(c->builder, same_type, value_block, post_block);
+
+  LLVMPositionBuilderAtEnd(c->builder, value_block);
+  r_value = gen_unbox(c, left_type, r_value);
+  LLVMValueRef is_value = gen_is_value(c, left_type, left_type, l_value,
+    r_value);
+  LLVMBuildBr(c->builder, post_block);
+  value_block = LLVMGetInsertBlock(c->builder);
+
+  LLVMPositionBuilderAtEnd(c->builder, post_block);
+  LLVMValueRef phi = LLVMBuildPhi(c->builder, c->i1, "");
+  LLVMValueRef zero = LLVMConstInt(c->i1, 0, false);
+  LLVMAddIncoming(phi, &is_value, &value_block, 1);
+  LLVMAddIncoming(phi, &zero, &this_block, 1);
+  return phi;
+}
+
+static LLVMValueRef box_is_box(compile_t* c, ast_t* left_type,
+  LLVMValueRef l_value, LLVMValueRef r_value, int possible_boxes)
+{
+  pony_assert(LLVMGetTypeKind(LLVMTypeOf(l_value)) == LLVMPointerTypeKind);
+  pony_assert(LLVMGetTypeKind(LLVMTypeOf(r_value)) == LLVMPointerTypeKind);
+
+  LLVMBasicBlockRef this_block = LLVMGetInsertBlock(c->builder);
+  LLVMBasicBlockRef checkbox_block = codegen_block(c, "is_checkbox");
+  LLVMBasicBlockRef box_block = codegen_block(c, "is_box");
+  LLVMBasicBlockRef num_block = NULL;
+  if((possible_boxes & BOXED_SUBTYPES_NUMERIC) != 0)
+    num_block = codegen_block(c, "is_num");
+  LLVMBasicBlockRef tuple_block = NULL;
+  if((possible_boxes & BOXED_SUBTYPES_TUPLE) != 0)
+    tuple_block = codegen_block(c, "is_tuple");
+  LLVMBasicBlockRef post_block = codegen_block(c, "is_post");
+
+  LLVMValueRef eq_addr = LLVMBuildICmp(c->builder, LLVMIntEQ, l_value, r_value,
+    "");
+  LLVMBuildCondBr(c->builder, eq_addr, post_block, checkbox_block);
+
+  // Check whether we have two boxed objects of the same type.
+  LLVMPositionBuilderAtEnd(c->builder, checkbox_block);
+  LLVMValueRef l_desc = gendesc_fetch(c, l_value);
+  LLVMValueRef r_desc = gendesc_fetch(c, r_value);
+  LLVMValueRef same_type = LLVMBuildICmp(c->builder, LLVMIntEQ, l_desc, r_desc,
+    "");
+  LLVMValueRef l_typeid = NULL;
+  if((possible_boxes & BOXED_SUBTYPES_UNBOXED) != 0)
+  {
+    l_typeid = gendesc_typeid(c, l_value);
+    LLVMValueRef boxed_mask = LLVMConstInt(c->i32, 1, false);
+    LLVMValueRef left_boxed = LLVMBuildAnd(c->builder, l_typeid, boxed_mask,
+      "");
+    LLVMValueRef zero = LLVMConstInt(c->i32, 0, false);
+    left_boxed = LLVMBuildICmp(c->builder, LLVMIntEQ, left_boxed, zero, "");
+    LLVMValueRef both_boxed = LLVMBuildAnd(c->builder, same_type, left_boxed,
+      "");
+    LLVMBuildCondBr(c->builder, both_boxed, box_block, post_block);
+  } else {
+    LLVMBuildCondBr(c->builder, same_type, box_block, post_block);
+  }
+
+  // Check whether it's a numeric primitive or a tuple.
+  LLVMPositionBuilderAtEnd(c->builder, box_block);
+  if((possible_boxes & BOXED_SUBTYPES_BOXED) == BOXED_SUBTYPES_BOXED)
+  {
+    if(l_typeid == NULL)
+      l_typeid = gendesc_typeid(c, l_value);
+    LLVMValueRef num_mask = LLVMConstInt(c->i32, 2, false);
+    LLVMValueRef boxed_num = LLVMBuildAnd(c->builder, l_typeid, num_mask, "");
+    LLVMValueRef zero = LLVMConstInt(c->i32, 0, false);
+    boxed_num = LLVMBuildICmp(c->builder, LLVMIntEQ, boxed_num, zero, "");
+    LLVMBuildCondBr(c->builder, boxed_num, num_block, tuple_block);
+  } else if((possible_boxes & BOXED_SUBTYPES_NUMERIC) != 0) {
+    LLVMBuildBr(c->builder, num_block);
+  } else {
+    pony_assert((possible_boxes & BOXED_SUBTYPES_TUPLE) != 0);
+    LLVMBuildBr(c->builder, tuple_block);
+  }
+
+  LLVMValueRef args[3];
+  LLVMValueRef is_num = NULL;
+  if(num_block != NULL)
+  {
+    // Get the machine word size and memcmp without unboxing.
+    LLVMPositionBuilderAtEnd(c->builder, num_block);
+    if(l_typeid == NULL)
+      l_typeid = gendesc_typeid(c, l_value);
+    LLVMValueRef num_sizes = LLVMBuildBitCast(c->builder, c->numeric_sizes,
+      c->void_ptr, "");
+    args[0] = LLVMBuildZExt(c->builder, l_typeid, c->intptr, "");
+    LLVMValueRef size = LLVMBuildInBoundsGEP(c->builder, num_sizes, args, 1,
+      "");
+    size = LLVMBuildBitCast(c->builder, size, LLVMPointerType(c->i32, 0), "");
+    size = LLVMBuildLoad(c->builder, size, "");
+    LLVMSetAlignment(size, 4);
+    LLVMValueRef one = LLVMConstInt(c->i32, 1, false);
+    args[0] = LLVMBuildInBoundsGEP(c->builder, l_value, &one, 1, "");
+    args[0] = LLVMBuildBitCast(c->builder, args[0], c->void_ptr, "");
+    args[1] = LLVMBuildInBoundsGEP(c->builder, r_value, &one, 1, "");
+    args[1] = LLVMBuildBitCast(c->builder, args[1], c->void_ptr, "");
+    args[2] = LLVMBuildZExt(c->builder, size, c->intptr, "");
+    is_num = gencall_runtime(c, "memcmp", args, 3, "");
+    is_num = LLVMBuildICmp(c->builder, LLVMIntEQ, is_num,
+      LLVMConstInt(c->i32, 0, false), "");
+    LLVMBuildBr(c->builder, post_block);
+  }
+
+  LLVMValueRef is_tuple = NULL;
+  if(tuple_block != NULL)
+  {
+    // Call the type-specific __is function, which will unbox the tuples.
+    LLVMPositionBuilderAtEnd(c->builder, tuple_block);
+    reach_type_t* r_left = reach_type(c->reach, left_type);
+    reach_method_t* is_fn = reach_method(r_left, TK_BOX, stringtab("__is"),
+      NULL);
+    pony_assert(is_fn != NULL);
+    LLVMValueRef func = gendesc_vtable(c, l_value, is_fn->vtable_index);
+    LLVMTypeRef params[2];
+    params[0] = c->object_ptr;
+    params[1] = c->object_ptr;
+    LLVMTypeRef type = LLVMFunctionType(c->i1, params, 2, false);
+    func = LLVMBuildBitCast(c->builder, func, LLVMPointerType(type, 0), "");
+    args[0] = l_value;
+    args[1] = r_value;
+    is_tuple = codegen_call(c, func, args, 2);
+    LLVMBuildBr(c->builder, post_block);
+  }
+
+  LLVMPositionBuilderAtEnd(c->builder, post_block);
+  LLVMValueRef phi = LLVMBuildPhi(c->builder, c->i1, "");
+  LLVMValueRef one = LLVMConstInt(c->i1, 1, false);
+  LLVMValueRef zero = LLVMConstInt(c->i1, 0, false);
+  LLVMAddIncoming(phi, &one, &this_block, 1);
+  if(is_num != NULL)
+    LLVMAddIncoming(phi, &is_num, &num_block, 1);
+  if(is_tuple != NULL)
+    LLVMAddIncoming(phi, &is_tuple, &tuple_block, 1);
+  LLVMAddIncoming(phi, &zero, &checkbox_block, 1);
+  return phi;
+}
+
 static LLVMValueRef gen_is_value(compile_t* c, ast_t* left_type,
   ast_t* right_type, LLVMValueRef l_value, LLVMValueRef r_value)
 {
@@ -75,7 +288,12 @@ static LLVMValueRef gen_is_value(compile_t* c, ast_t* left_type,
       if(l_type == r_type)
         return LLVMBuildICmp(c->builder, LLVMIntEQ, l_value, r_value, "");
 
-      // It can't have the same identity, even if it's the same value.
+      // If left_type is a subtype of right_type, check if r_value is a boxed
+      // numeric primitive.
+      if(is_subtype(left_type, right_type, NULL, c->opt))
+        return raw_is_box(c, left_type, l_value, r_value);
+
+      // It can't have the same identity.
       return LLVMConstInt(c->i1, 0, false);
     }
 
@@ -86,7 +304,12 @@ static LLVMValueRef gen_is_value(compile_t* c, ast_t* left_type,
       if(l_type == r_type)
         return LLVMBuildFCmp(c->builder, LLVMRealOEQ, l_value, r_value, "");
 
-      // It can't have the same identity, even if it's the same value.
+      // If left_type is a subtype of right_type, check if r_value is a boxed
+      // numeric primitive.
+      if(is_subtype(left_type, right_type, NULL, c->opt))
+        return raw_is_box(c, left_type,l_value, r_value);
+
+      // It can't have the same identity.
       return LLVMConstInt(c->i1, 0, false);
     }
 
@@ -96,20 +319,38 @@ static LLVMValueRef gen_is_value(compile_t* c, ast_t* left_type,
       if(LLVMGetTypeKind(r_type) == LLVMStructTypeKind)
         return tuple_is(c, left_type, right_type, l_value, r_value);
 
-      // It can't have the same identity, even if it's the same value.
+      // If left_type is a subtype of right_type, check if r_value is a boxed
+      // tuple.
+      if(is_subtype(left_type, right_type, NULL, c->opt))
+        return raw_is_box(c, left_type, l_value, r_value);
+
+      // It can't have the same identity.
       return LLVMConstInt(c->i1, 0, false);
     }
 
     case LLVMPointerTypeKind:
     {
-      // It can't have the same identity, even if it's the same value.
       if(LLVMGetTypeKind(r_type) != LLVMPointerTypeKind)
-        return LLVMConstInt(c->i1, 0, false);
+        return gen_is_value(c, right_type, left_type, r_value, l_value);
 
-      // Pointers must be to the same address.
       l_value = LLVMBuildBitCast(c->builder, l_value, c->object_ptr, "");
       r_value = LLVMBuildBitCast(c->builder, r_value, c->object_ptr, "");
-      return LLVMBuildICmp(c->builder, LLVMIntEQ, l_value, r_value, "");
+
+      if(!is_known(left_type) && !is_known(right_type))
+      {
+        int possible_boxes = boxed_subtypes_overlap(c->reach, left_type,
+          right_type);
+        if((possible_boxes & BOXED_SUBTYPES_BOXED) != 0)
+          return box_is_box(c, left_type, l_value, r_value, possible_boxes);
+      }
+
+      // If the types can be the same, check the address.
+      if(is_subtype(left_type, right_type, NULL, c->opt) ||
+        is_subtype(right_type, left_type, NULL, c->opt))
+        return LLVMBuildICmp(c->builder, LLVMIntEQ, l_value, r_value, "");
+
+      // It can't have the same identity.
+      return LLVMConstInt(c->i1, 0, false);
     }
 
     default: {}
@@ -159,3 +400,67 @@ LLVMValueRef gen_isnt(compile_t* c, ast_t* ast)
   codegen_debugloc(c, NULL);
   return value;
 }
+
+void gen_is_tuple_fun(compile_t* c, reach_type_t* t)
+{
+  pony_assert(t->underlying == TK_TUPLETYPE);
+
+  reach_method_t* m = reach_method(t, TK_BOX, stringtab("__is"), NULL);
+  pony_assert(m != NULL);
+
+  LLVMTypeRef params[2];
+  params[0] = t->structure_ptr;
+  params[1] = t->structure_ptr;
+  m->func_type = LLVMFunctionType(c->i1, params, 2, false);
+  m->func = codegen_addfun(c, m->full_name, m->func_type);
+
+  codegen_startfun(c, m->func, NULL, NULL);
+  LLVMValueRef l_value = LLVMGetParam(codegen_fun(c), 0);
+  LLVMValueRef r_value = LLVMGetParam(codegen_fun(c), 1);
+
+  l_value = gen_unbox(c, t->ast_cap, l_value);
+  r_value = gen_unbox(c, t->ast_cap, r_value);
+  LLVMBuildRet(c->builder, tuple_is(c, t->ast_cap, t->ast_cap, l_value,
+    r_value));
+
+  codegen_finishfun(c);
+}
+
+LLVMValueRef gen_numeric_size_table(compile_t* c)
+{
+  uint32_t len = c->reach->numeric_type_count;
+  if(len == 0)
+    return NULL;
+
+  size_t size = len * sizeof(LLVMValueRef);
+  LLVMValueRef* args = (LLVMValueRef*)ponyint_pool_alloc_size(size);
+
+  uint32_t count = 0;
+  reach_type_t* t;
+  size_t i = HASHMAP_BEGIN;
+
+  while(count < len)
+  {
+    t = reach_types_next(&c->reach->types, &i);
+    pony_assert(t != NULL);
+    uint32_t type_id = t->type_id;
+    if((type_id % 4) == 0)
+    {
+      size_t type_size = LLVMABISizeOfType(c->target_data, t->use_type);
+      args[type_id >> 2] = LLVMConstInt(c->i32, type_size, false);
+      count++;
+    }
+  }
+
+  LLVMTypeRef type = LLVMArrayType(c->i32, len);
+  LLVMValueRef table = LLVMAddGlobal(c->module, type, "__NumSizeTable");
+  LLVMValueRef value = LLVMConstArray(c->i32, args, len);
+  LLVMSetInitializer(table, value);
+  LLVMSetGlobalConstant(table, true);
+  LLVMSetAlignment(table, 4);
+  LLVMSetLinkage(table, LLVMPrivateLinkage);
+
+  ponyint_pool_free_size(size, args);
+
+  return table;
+}
diff --git a/src/libponyc/codegen/genident.h b/src/libponyc/codegen/genident.h
index 1b0d948a99..407c93e69c 100644
--- a/src/libponyc/codegen/genident.h
+++ b/src/libponyc/codegen/genident.h
@@ -10,6 +10,10 @@ LLVMValueRef gen_is(compile_t* c, ast_t* ast);
 
 LLVMValueRef gen_isnt(compile_t* c, ast_t* ast);
 
+void gen_is_tuple_fun(compile_t* c, reach_type_t* t);
+
+LLVMValueRef gen_numeric_size_table(compile_t* c);
+
 PONY_EXTERN_C_END
 
 #endif
diff --git a/src/libponyc/codegen/genlib.c b/src/libponyc/codegen/genlib.c
index 89d58608b9..33a17d3927 100644
--- a/src/libponyc/codegen/genlib.c
+++ b/src/libponyc/codegen/genlib.c
@@ -91,6 +91,8 @@ static bool reachable_actors(compile_t* c, ast_t* program)
     package = ast_sibling(package);
   }
 
+  reach_done(c->reach, c->opt);
+
   if(!found)
   {
     errorf(errors, NULL, "no C-API actors found in package '%s'", c->filename);
diff --git a/src/libponyc/codegen/genreference.c b/src/libponyc/codegen/genreference.c
index edec176c2d..efad34260c 100644
--- a/src/libponyc/codegen/genreference.c
+++ b/src/libponyc/codegen/genreference.c
@@ -1,4 +1,6 @@
 #include "genreference.h"
+#include "genbox.h"
+#include "gendesc.h"
 #include "genexpr.h"
 #include "genname.h"
 #include "gencall.h"
@@ -240,11 +242,98 @@ LLVMValueRef gen_addressof(compile_t* c, ast_t* ast)
   return NULL;
 }
 
-static LLVMValueRef gen_digestof_value(compile_t* c, LLVMValueRef value)
+enum subtype_kind_t
 {
-  LLVMTypeRef type = LLVMTypeOf(value);
+  SUBTYPE_KIND_NONE,
+  SUBTYPE_KIND_BOXED = 1 << 0,
+  SUBTYPE_KIND_UNBOXED = 1 << 1,
+  SUBTYPE_KIND_BOTH = SUBTYPE_KIND_BOXED | SUBTYPE_KIND_UNBOXED
+};
 
-  switch(LLVMGetTypeKind(type))
+static int has_boxed_subtype(reach_t* reach, ast_t* type)
+{
+  reach_type_t* t = reach_type(reach, type);
+
+  int subtypes = SUBTYPE_KIND_NONE;
+
+  size_t i = HASHMAP_BEGIN;
+  reach_type_t* sub;
+
+  while((sub = reach_type_cache_next(&t->subtypes, &i)) != NULL)
+  {
+    if(sub->can_be_boxed)
+      subtypes |= SUBTYPE_KIND_BOXED;
+    else
+      subtypes |= SUBTYPE_KIND_UNBOXED;
+
+    if(subtypes == SUBTYPE_KIND_BOTH)
+      return subtypes;
+  }
+
+  return subtypes;
+}
+
+static LLVMValueRef gen_digestof_box(compile_t* c, ast_t* type,
+  LLVMValueRef value, int boxed_subtype)
+{
+  pony_assert(LLVMGetTypeKind(LLVMTypeOf(value)) == LLVMPointerTypeKind);
+
+  LLVMBasicBlockRef box_block = NULL;
+  LLVMBasicBlockRef nonbox_block = NULL;
+  LLVMBasicBlockRef post_block = NULL;
+
+  if(boxed_subtype == SUBTYPE_KIND_BOTH)
+  {
+    box_block = codegen_block(c, "digestof_box");
+    nonbox_block = codegen_block(c, "digestof_nonbox");
+    post_block = codegen_block(c, "digestof_post");
+
+    // Check if it's a boxed value.
+    LLVMValueRef type_id = gendesc_typeid(c, value);
+    LLVMValueRef boxed_mask = LLVMConstInt(c->i32, 1, false);
+    LLVMValueRef is_boxed = LLVMBuildAnd(c->builder, type_id, boxed_mask, "");
+    LLVMValueRef zero = LLVMConstInt(c->i32, 0, false);
+    is_boxed = LLVMBuildICmp(c->builder, LLVMIntEQ, is_boxed, zero, "");
+    LLVMBuildCondBr(c->builder, is_boxed, box_block, nonbox_block);
+    LLVMPositionBuilderAtEnd(c->builder, box_block);
+  }
+
+  // Call the type-specific __digestof function, which will unbox the value.
+  reach_type_t* t = reach_type(c->reach, type);
+  reach_method_t* digest_fn = reach_method(t, TK_BOX, stringtab("__digestof"),
+    NULL);
+  pony_assert(digest_fn != NULL);
+  LLVMValueRef func = gendesc_vtable(c, value, digest_fn->vtable_index);
+  LLVMTypeRef fn_type = LLVMFunctionType(c->i64, &c->object_ptr, 1, false);
+  func = LLVMBuildBitCast(c->builder, func, LLVMPointerType(fn_type, 0), "");
+  LLVMValueRef box_digest = codegen_call(c, func, &value, 1);
+
+  if(boxed_subtype == SUBTYPE_KIND_BOTH)
+  {
+    LLVMBuildBr(c->builder, post_block);
+
+    // Just cast the address.
+    LLVMPositionBuilderAtEnd(c->builder, nonbox_block);
+    LLVMValueRef nonbox_digest = LLVMBuildPtrToInt(c->builder, value, c->i64,
+      "");
+    LLVMBuildBr(c->builder, post_block);
+
+    LLVMPositionBuilderAtEnd(c->builder, post_block);
+    LLVMValueRef phi = LLVMBuildPhi(c->builder, c->i64, "");
+    LLVMAddIncoming(phi, &box_digest, &box_block, 1);
+    LLVMAddIncoming(phi, &nonbox_digest, &nonbox_block, 1);
+    return phi;
+  } else {
+    return box_digest;
+  }
+}
+
+static LLVMValueRef gen_digestof_value(compile_t* c, ast_t* type,
+  LLVMValueRef value)
+{
+  LLVMTypeRef impl_type = LLVMTypeOf(value);
+
+  switch(LLVMGetTypeKind(impl_type))
   {
     case LLVMFloatTypeKind:
       value = LLVMBuildBitCast(c->builder, value, c->i32, "");
@@ -255,7 +344,7 @@ static LLVMValueRef gen_digestof_value(compile_t* c, LLVMValueRef value)
 
     case LLVMIntegerTypeKind:
     {
-      uint32_t width = LLVMGetIntTypeWidth(type);
+      uint32_t width = LLVMGetIntTypeWidth(impl_type);
 
       if(width < 64)
       {
@@ -273,20 +362,31 @@ static LLVMValueRef gen_digestof_value(compile_t* c, LLVMValueRef value)
 
     case LLVMStructTypeKind:
     {
-      uint32_t count = LLVMCountStructElementTypes(type);
+      uint32_t count = LLVMCountStructElementTypes(impl_type);
       LLVMValueRef result = LLVMConstInt(c->i64, 0, false);
+      ast_t* child = ast_child(type);
 
       for(uint32_t i = 0; i < count; i++)
       {
         LLVMValueRef elem = LLVMBuildExtractValue(c->builder, value, i, "");
-        elem = gen_digestof_value(c, elem);
+        elem = gen_digestof_value(c, child, elem);
         result = LLVMBuildXor(c->builder, result, elem, "");
+        child = ast_sibling(child);
       }
 
+      pony_assert(child == NULL);
+
       return result;
     }
 
     case LLVMPointerTypeKind:
+      if(!is_known(type))
+      {
+        int sub_kind = has_boxed_subtype(c->reach, type);
+        if((sub_kind & SUBTYPE_KIND_BOXED) != 0)
+          return gen_digestof_box(c, type, value, sub_kind);
+      }
+
       return LLVMBuildPtrToInt(c->builder, value, c->i64, "");
 
     default: {}
@@ -300,7 +400,26 @@ LLVMValueRef gen_digestof(compile_t* c, ast_t* ast)
 {
   ast_t* expr = ast_child(ast);
   LLVMValueRef value = gen_expr(c, expr);
-  return gen_digestof_value(c, value);
+  return gen_digestof_value(c, ast_type(expr), value);
+}
+
+void gen_digestof_fun(compile_t* c, reach_type_t* t)
+{
+  pony_assert(t->can_be_boxed);
+
+  reach_method_t* m = reach_method(t, TK_BOX, stringtab("__digestof"), NULL);
+  pony_assert(m != NULL);
+
+  m->func_type = LLVMFunctionType(c->i64, &t->structure_ptr, 1, false);
+  m->func = codegen_addfun(c, m->full_name, m->func_type);
+
+  codegen_startfun(c, m->func, NULL, NULL);
+  LLVMValueRef value = LLVMGetParam(codegen_fun(c), 0);
+
+  value = gen_unbox(c, t->ast_cap, value);
+  LLVMBuildRet(c->builder, gen_digestof_value(c, t->ast_cap, value));
+
+  codegen_finishfun(c);
 }
 
 LLVMValueRef gen_int(compile_t* c, ast_t* ast)
diff --git a/src/libponyc/codegen/genreference.h b/src/libponyc/codegen/genreference.h
index c89bdc74c5..47fa5f92ae 100644
--- a/src/libponyc/codegen/genreference.h
+++ b/src/libponyc/codegen/genreference.h
@@ -28,6 +28,8 @@ LLVMValueRef gen_addressof(compile_t* c, ast_t* ast);
 
 LLVMValueRef gen_digestof(compile_t* c, ast_t* ast);
 
+void gen_digestof_fun(compile_t* c, reach_type_t* t);
+
 LLVMValueRef gen_int(compile_t* c, ast_t* ast);
 
 LLVMValueRef gen_float(compile_t* c, ast_t* ast);
diff --git a/src/libponyc/codegen/gentype.c b/src/libponyc/codegen/gentype.c
index 68787c1e17..e7fb2b58fd 100644
--- a/src/libponyc/codegen/gentype.c
+++ b/src/libponyc/codegen/gentype.c
@@ -6,6 +6,8 @@
 #include "genfun.h"
 #include "genopt.h"
 #include "genserialise.h"
+#include "genident.h"
+#include "genreference.h"
 #include "../ast/id.h"
 #include "../pkg/package.h"
 #include "../type/cap.h"
@@ -624,6 +626,13 @@ static void make_debug_final(compile_t* c, reach_type_t* t)
 
 static void make_intrinsic_methods(compile_t* c, reach_type_t* t)
 {
+  if(t->can_be_boxed)
+  {
+    gen_digestof_fun(c, t);
+    if(ast_id(t->ast) == TK_TUPLETYPE)
+      gen_is_tuple_fun(c, t);
+  }
+
   if(ast_id(t->ast) != TK_NOMINAL)
     return;
 
@@ -744,6 +753,8 @@ bool gentypes(compile_t* c)
 
   gendesc_table(c);
 
+  c->numeric_sizes = gen_numeric_size_table(c);
+
   if(c->opt->verbosity >= VERBOSITY_INFO)
     fprintf(stderr, " Data types\n");
 
diff --git a/src/libponyc/reach/reach.c b/src/libponyc/reach/reach.c
index 750fd6c510..b8090ebba6 100644
--- a/src/libponyc/reach/reach.c
+++ b/src/libponyc/reach/reach.c
@@ -16,7 +16,8 @@ DEFINE_STACK(reach_method_stack, reach_method_stack_t,
   reach_method_t);
 
 static reach_method_t* add_rmethod(reach_t* r, reach_type_t* t,
-  reach_method_name_t* n, token_id cap, ast_t* typeargs, pass_opt_t* opt);
+  reach_method_name_t* n, token_id cap, ast_t* typeargs, pass_opt_t* opt,
+  bool internal);
 
 static reach_type_t* add_type(reach_t* r, ast_t* type, pass_opt_t* opt);
 
@@ -132,7 +133,8 @@ static reach_method_t* reach_rmethod(reach_method_name_t* n, const char* name)
   return reach_methods_get(&n->r_methods, &k, &index);
 }
 
-static reach_method_name_t* add_method_name(reach_type_t* t, const char* name)
+static reach_method_name_t* add_method_name(reach_type_t* t, const char* name,
+  bool internal)
 {
   reach_method_name_t* n = reach_method_name(t, name);
 
@@ -144,10 +146,18 @@ static reach_method_name_t* add_method_name(reach_type_t* t, const char* name)
     reach_mangled_init(&n->r_mangled, 0);
     reach_method_names_put(&t->methods, n);
 
-    ast_t* fun = lookup(NULL, NULL, t->ast, name);
-    n->id = ast_id(fun);
-    n->cap = ast_id(ast_child(fun));
-    ast_free_unattached(fun);
+    if(internal)
+    {
+      n->id = TK_FUN;
+      n->cap = TK_BOX;
+      n->internal = true;
+    } else {
+      ast_t* fun = lookup(NULL, NULL, t->ast, name);
+      n->id = ast_id(fun);
+      n->cap = ast_id(ast_child(fun));
+      ast_free_unattached(fun);
+      n->internal = false;
+    }
   }
 
   return n;
@@ -191,7 +201,8 @@ static const char* make_mangled_name(reach_method_t* m)
   for(size_t i = 0; i < m->param_count; i++)
     printbuf(buf, "%s", m->params[i].type->mangle);
 
-  printbuf(buf, "%s", m->result->mangle);
+  if(!m->internal)
+    printbuf(buf, "%s", m->result->mangle);
   const char* name = stringtab(buf->m);
   printbuf_free(buf);
   return name;
@@ -212,8 +223,8 @@ static void add_rmethod_to_subtype(reach_t* r, reach_type_t* t,
   reach_method_name_t* n, reach_method_t* m, pass_opt_t* opt)
 {
   // Add the method to the type if it isn't already there.
-  reach_method_name_t* n2 = add_method_name(t, n->name);
-  add_rmethod(r, t, n2, m->cap, m->typeargs, opt);
+  reach_method_name_t* n2 = add_method_name(t, n->name, false);
+  add_rmethod(r, t, n2, m->cap, m->typeargs, opt, false);
 
   // Add this mangling to the type if it isn't already there.
   size_t index = HASHMAP_UNKNOWN;
@@ -303,7 +314,8 @@ static void add_rmethod_to_subtypes(reach_t* r, reach_type_t* t,
 }
 
 static reach_method_t* add_rmethod(reach_t* r, reach_type_t* t,
-  reach_method_name_t* n, token_id cap, ast_t* typeargs, pass_opt_t* opt)
+  reach_method_name_t* n, token_id cap, ast_t* typeargs, pass_opt_t* opt,
+  bool internal)
 {
   const char* name = genname_fun(cap, n->name, typeargs);
   reach_method_t* m = reach_rmethod(n, name);
@@ -317,22 +329,28 @@ static reach_method_t* add_rmethod(reach_t* r, reach_type_t* t,
   m->cap = cap;
   m->typeargs = ast_dup(typeargs);
   m->vtable_index = (uint32_t)-1;
+  m->internal = internal;
+  m->intrinsic = internal;
 
-  ast_t* r_ast = set_cap_and_ephemeral(t->ast, cap, TK_NONE);
-  ast_t* fun = lookup(NULL, NULL, r_ast, n->name);
-  ast_free_unattached(r_ast);
-
-  if(typeargs != NULL)
+  if(!internal)
   {
-    // Reify the method with its typeargs, if it has any.
-    AST_GET_CHILDREN(fun, cap, id, typeparams, params, result, can_error,
-      body);
+    ast_t* r_ast = set_cap_and_ephemeral(t->ast, cap, TK_NONE);
+    ast_t* fun = lookup(NULL, NULL, r_ast, n->name);
+    ast_free_unattached(r_ast);
+
+    if(typeargs != NULL)
+    {
+      // Reify the method with its typeargs, if it has any.
+      AST_GET_CHILDREN(fun, cap, id, typeparams, params, result, can_error,
+        body);
 
-    fun = reify(fun, typeparams, typeargs, opt, false);
+      fun = reify(fun, typeparams, typeargs, opt, false);
+    }
+
+    m->r_fun = fun;
+    set_method_types(r, m, opt);
   }
 
-  m->r_fun = fun;
-  set_method_types(r, m, opt);
   m->mangled_name = make_mangled_name(m);
   m->full_name = make_full_name(t, m);
 
@@ -340,11 +358,14 @@ static reach_method_t* add_rmethod(reach_t* r, reach_type_t* t,
   reach_methods_put(&n->r_methods, m);
   reach_mangled_put(&n->r_mangled, m);
 
-  // Put on a stack of reachable methods to trace.
-  r->stack = reach_method_stack_push(r->stack, m);
+  if(!internal)
+  {
+    // Put on a stack of reachable methods to trace.
+    r->stack = reach_method_stack_push(r->stack, m);
 
-  // Add the method to any subtypes.
-  add_rmethod_to_subtypes(r, t, n, m, opt);
+    // Add the method to any subtypes.
+    add_rmethod_to_subtypes(r, t, n, m, opt);
+  }
 
   return m;
 }
@@ -357,6 +378,9 @@ static void add_methods_to_type(reach_t* r, reach_type_t* from,
 
   while((n = reach_method_names_next(&from->methods, &i)) != NULL)
   {
+    if(n->internal)
+      continue;
+
     size_t j = HASHMAP_BEGIN;
     reach_method_t* m;
 
@@ -380,34 +404,40 @@ static void add_types_to_trait(reach_t* r, reach_type_t* t,
 
   while((t2 = reach_types_next(&r->types, &i)) != NULL)
   {
-    if(ast_id(t2->ast) != TK_NOMINAL)
-      continue;
-
-    ast_t* def2 = (ast_t*)ast_data(t2->ast);
-
-    switch(ast_id(def2))
+    if(ast_id(t2->ast) == TK_NOMINAL)
     {
-      case TK_INTERFACE:
-      {
-        // Use the same typeid.
-        if(interface && is_eqtype(t->ast, t2->ast, NULL, opt))
-          t->type_id = t2->type_id;
-        break;
-      }
+      ast_t* def2 = (ast_t*)ast_data(t2->ast);
 
-      case TK_PRIMITIVE:
-      case TK_CLASS:
-      case TK_ACTOR:
-        if(is_subtype(t2->ast, t->ast, NULL, opt))
+      switch(ast_id(def2))
+      {
+        case TK_INTERFACE:
         {
-          reach_type_cache_put(&t->subtypes, t2);
-          reach_type_cache_put(&t2->subtypes, t);
-          if(ast_id(t->ast) == TK_NOMINAL)
-            add_methods_to_type(r, t, t2, opt);
+          // Use the same typeid.
+          if(interface && is_eqtype(t->ast, t2->ast, NULL, opt))
+            t->type_id = t2->type_id;
+          break;
         }
-        break;
 
-      default: {}
+        case TK_PRIMITIVE:
+        case TK_CLASS:
+        case TK_ACTOR:
+          if(is_subtype(t2->ast, t->ast, NULL, opt))
+          {
+            reach_type_cache_put(&t->subtypes, t2);
+            reach_type_cache_put(&t2->subtypes, t);
+            if(ast_id(t->ast) == TK_NOMINAL)
+              add_methods_to_type(r, t, t2, opt);
+          }
+          break;
+
+        default: {}
+      }
+    } else if(ast_id(t2->ast) == TK_TUPLETYPE) {
+      if(is_subtype(t2->ast, t->ast, NULL, opt))
+      {
+        reach_type_cache_put(&t->subtypes, t2);
+        reach_type_cache_put(&t2->subtypes, t);
+      }
     }
   }
 }
@@ -624,6 +654,7 @@ static reach_type_t* add_reach_type(reach_t* r, ast_t* type)
   t->name = genname_type(type);
   t->mangle = "o";
   t->ast = set_cap_and_ephemeral(type, TK_REF, TK_NONE);
+  t->ast_cap = ast_dup(type);
   t->type_id = (uint32_t)-1;
 
   reach_method_names_init(&t->methods, 0);
@@ -643,7 +674,7 @@ static reach_type_t* add_isect_or_union(reach_t* r, ast_t* type,
 
   t = add_reach_type(r, type);
   t->underlying = ast_id(t->ast);
-  t->type_id = r->next_type_id++;
+  t->type_id = (r->object_type_count++ * 2) + 1;
 
   add_types_to_trait(r, t, opt);
 
@@ -670,13 +701,21 @@ static reach_type_t* add_tuple(reach_t* r, ast_t* type, pass_opt_t* opt)
 
   t = add_reach_type(r, type);
   t->underlying = TK_TUPLETYPE;
-  t->type_id = r->next_type_id++;
+  t->type_id = (r->tuple_type_count++ * 4) + 2;
   t->can_be_boxed = true;
 
   t->field_count = (uint32_t)ast_childcount(t->ast);
   t->fields = (reach_field_t*)calloc(t->field_count,
     sizeof(reach_field_t));
 
+  add_traits_to_type(r, t, opt);
+
+  reach_method_name_t* n = add_method_name(t, stringtab("__is"), true);
+  add_rmethod(r, t, n, TK_BOX, NULL, opt, true);
+
+  n = add_method_name(t, stringtab("__digestof"), true);
+  add_rmethod(r, t, n, TK_BOX, NULL, opt, true);
+
   printbuf_t* mangle = printbuf_new();
   printbuf(mangle, "%d", t->field_count);
 
@@ -729,6 +768,13 @@ static reach_type_t* add_nominal(reach_t* r, ast_t* type, pass_opt_t* opt)
       add_traits_to_type(r, t, opt);
       add_special(r, t, type, "_init", opt);
       add_special(r, t, type, "_final", opt);
+      if(is_machine_word(type))
+      {
+        reach_method_name_t* n = add_method_name(t, stringtab("__digestof"),
+          true);
+        add_rmethod(r, t, n, TK_BOX, NULL, opt, true);
+        t->can_be_boxed = true;
+      }
       break;
 
     case TK_STRUCT:
@@ -749,10 +795,12 @@ static reach_type_t* add_nominal(reach_t* r, ast_t* type, pass_opt_t* opt)
   }
 
   if(t->type_id == (uint32_t)-1)
-    t->type_id = r->next_type_id++;
-
-  if(is_machine_word(type))
-    t->can_be_boxed = true;
+  {
+    if(t->can_be_boxed)
+      t->type_id = r->numeric_type_count++ * 4;
+    else
+      t->type_id = (r->object_type_count++ * 2) + 1;
+  }
 
   if(ast_id(def) != TK_PRIMITIVE)
     return t;
@@ -1035,6 +1083,27 @@ static void reachable_expr(reach_t* r, ast_t* ast, pass_opt_t* opt)
       break;
     }
 
+    case TK_IS:
+    {
+      AST_GET_CHILDREN(ast, left, right);
+
+      ast_t* l_type = ast_type(left);
+      ast_t* r_type = ast_type(right);
+
+      add_type(r, l_type, opt);
+      add_type(r, r_type, opt);
+      break;
+    }
+
+    case TK_DIGESTOF:
+    {
+      ast_t* expr = ast_child(ast);
+      ast_t* type = ast_type(expr);
+
+      add_type(r, type, opt);
+      break;
+    }
+
     default: {}
   }
 
@@ -1052,8 +1121,8 @@ static void reachable_method(reach_t* r, ast_t* type, const char* name,
   ast_t* typeargs, pass_opt_t* opt)
 {
   reach_type_t* t = add_type(r, type, opt);
-  reach_method_name_t* n = add_method_name(t, name);
-  reach_method_t* m = add_rmethod(r, t, n, n->cap, typeargs, opt);
+  reach_method_name_t* n = add_method_name(t, name, false);
+  reach_method_t* m = add_rmethod(r, t, n, n->cap, typeargs, opt, false);
 
   if((n->id == TK_FUN) && ((n->cap == TK_BOX) || (n->cap == TK_TAG)))
   {
@@ -1072,7 +1141,7 @@ static void reachable_method(reach_t* r, ast_t* type, const char* name,
 
     if(t->underlying != TK_PRIMITIVE)
     {
-      m2 = add_rmethod(r, t, n, TK_REF, typeargs, opt);
+      m2 = add_rmethod(r, t, n, TK_REF, typeargs, opt, false);
 
       if(subordinate)
       {
@@ -1082,7 +1151,7 @@ static void reachable_method(reach_t* r, ast_t* type, const char* name,
       }
     }
 
-    m2 = add_rmethod(r, t, n, TK_VAL, typeargs, opt);
+    m2 = add_rmethod(r, t, n, TK_VAL, typeargs, opt, false);
 
     if(subordinate)
     {
@@ -1093,7 +1162,7 @@ static void reachable_method(reach_t* r, ast_t* type, const char* name,
 
     if(n->cap == TK_TAG)
     {
-      m2 = add_rmethod(r, t, n, TK_BOX, typeargs, opt);
+      m2 = add_rmethod(r, t, n, TK_BOX, typeargs, opt, false);
       m2->intrinsic = true;
       m->subordinate = m2;
       m = m2;
@@ -1117,7 +1186,10 @@ reach_t* reach_new()
 {
   reach_t* r = POOL_ALLOC(reach_t);
   r->stack = NULL;
-  r->next_type_id = 0;
+  r->object_type_count = 0;
+  r->numeric_type_count = 0;
+  r->tuple_type_count = 0;
+  r->total_type_count = 0;
   reach_types_init(&r->types, 64);
   return r;
 }
@@ -1138,6 +1210,59 @@ void reach(reach_t* r, ast_t* type, const char* name, ast_t* typeargs,
   handle_stack(r, opt);
 }
 
+static void add_internal_rmethod_to_traits(reach_t* r, reach_type_t* t,
+  const char* name, pass_opt_t* opt)
+{
+  size_t i = HASHMAP_BEGIN;
+  reach_type_t* super;
+
+  // For concrete types, subtypes is a map of supertypes.
+  while((super = reach_type_cache_next(&t->subtypes, &i)) != NULL)
+  {
+    reach_method_name_t* n = add_method_name(super, name, true);
+    add_rmethod(r, super, n, TK_BOX, NULL, opt, true);
+  }
+}
+
+void reach_done(reach_t* r, pass_opt_t* opt)
+{
+  // Type IDs are assigned as:
+  // - Object type IDs:   1, 3, 5, 7, 9, ...
+  // - Numeric type IDs: 0, 4, 8, 12, 16, ...
+  // - Tuple type IDs:   2, 6, 10, 14, 18, ...
+  // This allows to quickly check whether a type is unboxed or not.
+
+  r->total_type_count = r->object_type_count + r->numeric_type_count +
+    r->tuple_type_count;
+
+  size_t i = HASHMAP_BEGIN;
+  reach_type_t* t;
+  while((t = reach_types_next(&r->types, &i)) != NULL)
+  {
+    switch(t->underlying)
+    {
+      case TK_UNIONTYPE:
+      case TK_ISECTTYPE:
+      case TK_INTERFACE:
+      case TK_TRAIT:
+        continue;
+
+      default: {}
+    }
+
+    // Add internal methods to supertypes.
+    size_t j = HASHMAP_BEGIN;
+    reach_method_name_t* n;
+    while((n = reach_method_names_next(&t->methods, &j)) != NULL)
+    {
+      if(!n->internal)
+        continue;
+
+      add_internal_rmethod_to_traits(r, t, n->name, opt);
+    }
+  }
+}
+
 reach_type_t* reach_type(reach_t* r, ast_t* type)
 {
   reach_type_t k;
diff --git a/src/libponyc/reach/reach.h b/src/libponyc/reach/reach.h
index 1004be2b09..158b17be4b 100644
--- a/src/libponyc/reach/reach.h
+++ b/src/libponyc/reach/reach.h
@@ -45,6 +45,11 @@ struct reach_method_t
   // Mark as true if the compiler supplies an implementation.
   bool intrinsic;
 
+  // Mark as true if the compiler supplies an implementation and the function
+  // isn't exposed to the user at all. The method will also be automatically
+  // added to supertypes.
+  bool internal;
+
   // Mark as true if the method is a forwarding method.
   bool forwarding;
 
@@ -63,6 +68,7 @@ struct reach_method_name_t
   const char* name;
   reach_methods_t r_methods;
   reach_mangled_t r_mangled;
+  bool internal;
 };
 
 struct reach_field_t
@@ -83,6 +89,7 @@ struct reach_type_t
   const char* name;
   const char* mangle;
   ast_t* ast;
+  ast_t* ast_cap;
   token_id underlying;
 
   reach_method_names_t methods;
@@ -120,7 +127,10 @@ typedef struct
 {
   reach_types_t types;
   reach_method_stack_t* stack;
-  uint32_t next_type_id;
+  uint32_t object_type_count;
+  uint32_t numeric_type_count;
+  uint32_t tuple_type_count;
+  uint32_t total_type_count;
 } reach_t;
 
 /// Allocate a new set of reachable types.
@@ -137,6 +147,13 @@ void reach_free(reach_t* r);
 void reach(reach_t* r, ast_t* type, const char* name, ast_t* typeargs,
   pass_opt_t* opt);
 
+/** Finalise reached types before use.
+ *
+ * This must be called once all the necessary reachability analysis has been
+ * done and before using the data.
+ */
+void reach_done(reach_t* r, pass_opt_t* opt);
+
 reach_type_t* reach_type(reach_t* r, ast_t* type);
 
 reach_type_t* reach_type_name(reach_t* r, const char* name);
diff --git a/test/libponyc/codegen_identity.cc b/test/libponyc/codegen_identity.cc
new file mode 100644
index 0000000000..b0a04a82be
--- /dev/null
+++ b/test/libponyc/codegen_identity.cc
@@ -0,0 +1,261 @@
+#include <gtest/gtest.h>
+#include <platform.h>
+
+#include "util.h"
+
+#define TEST_COMPILE(src) DO(test_compile(src, "ir"))
+
+
+class CodegenIdentityTest : public PassTest
+{};
+
+
+extern "C"
+{
+
+EXPORT_SYMBOL intptr_t ptr_to_int(void* p)
+{
+  return (intptr_t)p;
+}
+
+}
+
+
+TEST_F(CodegenIdentityTest, ObjectIsObject)
+{
+  const char* src =
+    "class C1\n"
+    "class C2\n"
+
+    "actor Main\n"
+    "  new create(env: Env) =>\n"
+    "    let c1: Any = C1\n"
+    "    let c2: Any = C2\n"
+    "    if (c1 is c1) and (c1 isnt c2) then\n"
+    "      @pony_exitcode[None](I32(1))\n"
+    "    end";
+
+  TEST_COMPILE(src);
+
+  int exit_code = 0;
+  ASSERT_TRUE(run_program(&exit_code));
+  ASSERT_EQ(exit_code, 1);
+}
+
+
+TEST_F(CodegenIdentityTest, NumericIsNumeric)
+{
+  const char* src =
+    "actor Main\n"
+    "  new create(env: Env) =>\n"
+    "    if (U32(0) is U32(0)) and (U32(0) isnt U32(1)) and\n"
+    "      (U32(0) isnt U64(0))\n"
+    "    then\n"
+    "      @pony_exitcode[None](I32(1))\n"
+    "    end";
+
+  TEST_COMPILE(src);
+
+  int exit_code = 0;
+  ASSERT_TRUE(run_program(&exit_code));
+  ASSERT_EQ(exit_code, 1);
+}
+
+
+TEST_F(CodegenIdentityTest, TupleIsTuple)
+{
+  const char* src =
+    "actor Main\n"
+    "  new create(env: Env) =>\n"
+    "    let a: (Any, Any) = (U32(0), env)\n"
+    "    let b: (Any, Any) = (U32(1), this)\n"
+    "    if (a is a) and (a isnt b) then\n"
+    "      @pony_exitcode[None](I32(1))\n"
+    "    end";
+
+  TEST_COMPILE(src);
+
+  int exit_code = 0;
+  ASSERT_TRUE(run_program(&exit_code));
+  ASSERT_EQ(exit_code, 1);
+}
+
+
+TEST_F(CodegenIdentityTest, NumericIsBoxedNumeric)
+{
+  const char* src =
+    "actor Main\n"
+    "  new create(env: Env) =>\n"
+    "    let boxed: (Any | (U32, U32)) = U32(0)\n"
+    "    if (U32(0) is boxed) and (U32(1) isnt boxed) and\n"
+    "      (U64(0) isnt boxed)\n"
+    "    then\n"
+    "      @pony_exitcode[None](I32(1))\n"
+    "    end";
+
+  TEST_COMPILE(src);
+
+  int exit_code = 0;
+  ASSERT_TRUE(run_program(&exit_code));
+  ASSERT_EQ(exit_code, 1);
+}
+
+
+TEST_F(CodegenIdentityTest, BoxedNumericIsBoxedNumeric)
+{
+  const char* src =
+    "actor Main\n"
+    "  new create(env: Env) =>\n"
+    "    let u32_0_a: (Any | (U32, U32)) = U32(0)\n"
+    "    let u32_0_b: (Any | (U32, U32)) = U32(0)\n"
+    "    let u32_1: (Any | (U32, U32)) = U32(1)\n"
+    "    let u64_0: (Any | (U32, U32)) = U64(0)\n"
+    "    if (u32_0_a is u32_0_a) and (u32_0_a is u32_0_b) and\n"
+    "      (u32_0_a isnt u32_1) and (u32_0_a isnt u64_0)\n"
+    "    then\n"
+    "      @pony_exitcode[None](I32(1))\n"
+    "    end";
+
+  TEST_COMPILE(src);
+
+  int exit_code = 0;
+  ASSERT_TRUE(run_program(&exit_code));
+  ASSERT_EQ(exit_code, 1);
+}
+
+
+TEST_F(CodegenIdentityTest, TupleIsBoxedTuple)
+{
+  const char* src =
+    "actor Main\n"
+    "  new create(env: Env) =>\n"
+    "    let boxed: (Any | (U32, U32) | (U64, U64)) = (U32(0), U32(0))\n"
+    "    if ((U32(0), U32(0)) is boxed) and ((U32(1), U32(0)) isnt boxed) and\n"
+    "      ((U64(0), U64(0)) isnt boxed)\n"
+    "    then\n"
+    "      @pony_exitcode[None](I32(1))\n"
+    "    end";
+
+  TEST_COMPILE(src);
+
+  int exit_code = 0;
+  ASSERT_TRUE(run_program(&exit_code));
+  ASSERT_EQ(exit_code, 1);
+}
+
+
+TEST_F(CodegenIdentityTest, BoxedTupleIsBoxedTuple)
+{
+  const char* src =
+    "actor Main\n"
+    "  new create(env: Env) =>\n"
+    "    let t1_a: (Any | (U32, U32) | (U64, U64)) = (U32(0), U32(0))\n"
+    "    let t1_b: (Any | (U32, U32) | (U64, U64)) = (U32(0), U32(0))\n"
+    "    let t2: (Any | (U32, U32) | (U64, U64)) = (U32(1), U32(0))\n"
+    "    let t3: (Any | (U32, U32) | (U64, U64)) = (U64(0), U64(0))\n"
+    "    if (t1_a is t1_a) and (t1_a is t1_b) and (t1_a isnt t2) and\n"
+    "      (t1_a isnt t3)\n"
+    "    then\n"
+    "      @pony_exitcode[None](I32(1))\n"
+    "    end";
+
+  TEST_COMPILE(src);
+
+  int exit_code = 0;
+  ASSERT_TRUE(run_program(&exit_code));
+  ASSERT_EQ(exit_code, 1);
+}
+
+
+TEST_F(CodegenIdentityTest, DigestofObject)
+{
+  const char* src =
+    "actor Main\n"
+    "  new create(env: Env) =>\n"
+    "    let dg = digestof env\n"
+    "    if dg == @ptr_to_int[ISize](env).u64() then\n"
+    "      @pony_exitcode[None](I32(1))\n"
+    "    end";
+
+  TEST_COMPILE(src);
+
+  int exit_code = 0;
+  ASSERT_TRUE(run_program(&exit_code));
+  ASSERT_EQ(exit_code, 1);
+}
+
+
+TEST_F(CodegenIdentityTest, DigestofNumeric)
+{
+  const char* src =
+    "actor Main\n"
+    "  new create(env: Env) =>\n"
+    "    let value = U32(5)\n"
+    "    let dg = digestof value\n"
+    "    if dg == 5 then\n"
+    "      @pony_exitcode[None](I32(1))\n"
+    "    end";
+
+  TEST_COMPILE(src);
+
+  int exit_code = 0;
+  ASSERT_TRUE(run_program(&exit_code));
+  ASSERT_EQ(exit_code, 1);
+}
+
+
+TEST_F(CodegenIdentityTest, DigestofTuple)
+{
+  const char* src =
+    "actor Main\n"
+    "  new create(env: Env) =>\n"
+    "    let value = (this, env)\n"
+    "    let dg = digestof value\n"
+    "    if dg == ((digestof this) xor (digestof env)) then\n"
+    "      @pony_exitcode[None](I32(1))\n"
+    "    end";
+
+  TEST_COMPILE(src);
+
+  int exit_code = 0;
+  ASSERT_TRUE(run_program(&exit_code));
+  ASSERT_EQ(exit_code, 1);
+}
+
+
+TEST_F(CodegenIdentityTest, DigestofBoxedNumeric)
+{
+  const char* src =
+    "actor Main\n"
+    "  new create(env: Env) =>\n"
+    "    let boxed: (Any | (U32, U32)) = U32(5)\n"
+    "    let dg = digestof boxed\n"
+    "    if dg == 5 then\n"
+    "      @pony_exitcode[None](I32(1))\n"
+    "    end";
+
+  TEST_COMPILE(src);
+
+  int exit_code = 0;
+  ASSERT_TRUE(run_program(&exit_code));
+  ASSERT_EQ(exit_code, 1);
+}
+
+
+TEST_F(CodegenIdentityTest, DigestofBoxedTuple)
+{
+  const char* src =
+    "actor Main\n"
+    "  new create(env: Env) =>\n"
+    "    let boxed: (Any | (Main, Env)) = (this, env)\n"
+    "    let dg = digestof boxed\n"
+    "    if dg == ((digestof this) xor (digestof env)) then\n"
+    "      @pony_exitcode[None](I32(1))\n"
+    "    end";
+
+  TEST_COMPILE(src);
+
+  int exit_code = 0;
+  ASSERT_TRUE(run_program(&exit_code));
+  ASSERT_EQ(exit_code, 1);
+}
diff --git a/test/libponyc/reach.cc b/test/libponyc/reach.cc
index 0353adefc9..c5ec427eb7 100644
--- a/test/libponyc/reach.cc
+++ b/test/libponyc/reach.cc
@@ -2,6 +2,7 @@
 #include <platform.h>
 
 #include <reach/reach.h>
+#include <type/subtype.h>
 
 #include "util.h"
 
@@ -17,16 +18,19 @@ TEST_F(ReachTest, IsectHasSubtypes)
 {
   const char* src =
     "trait TA\n"
-    "  fun a() => None\n"
+    "  fun a()\n"
 
     "trait TB\n"
-    "  fun b() => None\n"
+    "  fun b()\n"
 
     "actor Main is (TA & TB)\n"
     "  new create(env: Env) =>\n"
     "    let ab: (TA & TB) = this\n"
     "    ab.a()\n"
-    "    ab.b()";
+    "    ab.b()\n"
+
+    "  fun a() => None\n"
+    "  fun b() => None";
 
   TEST_COMPILE(src);
 
diff --git a/test/libponyc/util.cc b/test/libponyc/util.cc
index b2a34c4315..6e31447b0e 100644
--- a/test/libponyc/util.cc
+++ b/test/libponyc/util.cc
@@ -33,21 +33,22 @@ static const char* _builtin =
   "  fun mul(a: U8): U8 => this * a\n"
   "primitive I8 is Real[I8]"
   "  new create(a: I8 = 0) => a\n"
-  "  fun neg():I8 => -this\n"
+  "  fun neg(): I8 => -this\n"
   "primitive U16 is Real[U16]"
   "  new create(a: U16 = 0) => a\n"
   "primitive I16 is Real[I16]"
   "  new create(a: I16 = 0) => a\n"
-  "  fun neg():I16 => -this\n"
+  "  fun neg(): I16 => -this\n"
   "  fun mul(a: I16): I16 => this * a\n"
   "primitive U32 is Real[U32]"
   "  new create(a: U32 = 0) => a\n"
   "primitive I32 is Real[I32]"
   "  new create(a: I32 = 0) => a\n"
-  "  fun neg():I32 => -this\n"
+  "  fun neg(): I32 => -this\n"
   "  fun mul(a: I32): I32 => this * a\n"
   "primitive U64 is Real[U64]"
   "  new create(a: U64 = 0) => a\n"
+  "  fun op_xor(a: U64): U64 => this xor a\n"
   "primitive I64 is Real[I64]"
   "  new create(a: I64 = 0) => a\n"
   "  fun neg():I64 => -this\n"
@@ -61,17 +62,18 @@ static const char* _builtin =
   "  fun div(a: U128): U128 => this / a\n"
   "primitive I128 is Real[I128]"
   "  new create(a: I128 = 0) => a\n"
-  "  fun neg():I128 => -this\n"
+  "  fun neg(): I128 => -this\n"
   "primitive ULong is Real[ULong]"
   "  new create(a: ULong = 0) => a\n"
   "primitive ILong is Real[ILong]"
   "  new create(a: ILong = 0) => a\n"
-  "  fun neg():ILong => -this\n"
+  "  fun neg(): ILong => -this\n"
   "primitive USize is Real[USize]"
   "  new create(a: USize = 0) => a\n"
   "primitive ISize is Real[ISize]"
   "  new create(a: ISize = 0) => a\n"
-  "  fun neg():ISize => -this\n"
+  "  fun neg(): ISize => -this\n"
+  "  fun u64(): U64 => compile_intrinsic\n"
   "primitive F32 is Real[F32]"
   "  new create(a: F32 = 0) => a\n"
   "primitive F64 is Real[F64]"
